# all files / ol/style/ imagestyle.js

87.8% Statements 36/41
100% Branches 0/0
54.55% Functions 6/11
87.8% Lines 36/41

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    2541×
    1×

    1×

    1×

    1×

    137×

    137×

    137×

    137×

    137×

    1×
    17×

    1×
    18×

    1×
    20×

    1×
    20×

    1×
    12×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×
     goog.provide('ol.style.Image');
    goog.provide('ol.style.ImageState');

    /**
     * @enum {number}
     */
    ol.style.ImageState = {
      IDLE: 0,
      LOADING: 1,
      LOADED: 2,
      ERROR: 3
    };

    /**
     * @typedef {{opacity: number,
     *            rotateWithView: boolean,
     *            rotation: number,
     *            scale: number,
     *            snapToPixel: boolean}}
     */
    ol.style.ImageOptions;

    /**
     * @classdesc
     * A base class used for creating subclasses and not instantiated in
     * apps. Base class for {@link ol.style.Icon}, {@link ol.style.Circle} and
     * {@link ol.style.RegularShape}.
     *
     * @constructor
     * @param {ol.style.ImageOptions} options Options.
     * @api
     */
    ol.style.Image = function(options) {

      /**
       * @private
       * @type {number}
       */
      this.opacity_ = options.opacity;

      /**
       * @private
       * @type {boolean}
       */
      this.rotateWithView_ = options.rotateWithView;

      /**
       * @private
       * @type {number}
       */
      this.rotation_ = options.rotation;

      /**
       * @private
       * @type {number}
       */
      this.scale_ = options.scale;

      /**
       * @private
       * @type {boolean}
       */
      this.snapToPixel_ = options.snapToPixel;

    };

    /**
     * Get the symbolizer opacity.
     * @return {number} Opacity.
     * @api
     */
    ol.style.Image.prototype.getOpacity = function() {
      return this.opacity_;
    };

    /**
     * Determine whether the symbolizer rotates with the map.
     * @return {boolean} Rotate with map.
     * @api
     */
    ol.style.Image.prototype.getRotateWithView = function() {
      return this.rotateWithView_;
    };

    /**
     * Get the symoblizer rotation.
     * @return {number} Rotation.
     * @api
     */
    ol.style.Image.prototype.getRotation = function() {
      return this.rotation_;
    };

    /**
     * Get the symbolizer scale.
     * @return {number} Scale.
     * @api
     */
    ol.style.Image.prototype.getScale = function() {
      return this.scale_;
    };

    /**
     * Determine whether the symbolizer should be snapped to a pixel.
     * @return {boolean} The symbolizer should snap to a pixel.
     * @api
     */
    ol.style.Image.prototype.getSnapToPixel = function() {
      return this.snapToPixel_;
    };

    /**
     * Get the anchor point.  The anchor determines the center point for the
     * symbolizer.  Its units are determined by `anchorXUnits` and `anchorYUnits`.
     * @function
     * @return {Array.<number>} Anchor.
     */
    ol.style.Image.prototype.getAnchor = goog.abstractMethod;

    /**
     * Get the image element for the symbolizer.
     * @function
     * @param {number} pixelRatio Pixel ratio.
     * @return {HTMLCanvasElement|HTMLVideoElement|Image} Image element.
     */
    ol.style.Image.prototype.getImage = goog.abstractMethod;

    /**
     * @param {number} pixelRatio Pixel ratio.
     * @return {HTMLCanvasElement|HTMLVideoElement|Image} Image element.
     */
    ol.style.Image.prototype.getHitDetectionImage = goog.abstractMethod;

    /**
     * @return {ol.style.ImageState} Image state.
     */
    ol.style.Image.prototype.getImageState = goog.abstractMethod;

    /**
     * @return {ol.Size} Image size.
     */
    ol.style.Image.prototype.getImageSize = goog.abstractMethod;

    /**
     * @return {ol.Size} Size of the hit-detection image.
     */
    ol.style.Image.prototype.getHitDetectionImageSize = goog.abstractMethod;

    /**
     * Get the origin of the symbolizer.
     * @function
     * @return {Array.<number>} Origin.
     */
    ol.style.Image.prototype.getOrigin = goog.abstractMethod;

    /**
     * Get the size of the symbolizer (in pixels).
     * @function
     * @return {ol.Size} Size.
     */
    ol.style.Image.prototype.getSize = goog.abstractMethod;

    /**
     * Set the opacity.
     *
     * @param {number} opacity Opacity.
     * @api
     */
    ol.style.Image.prototype.setOpacity = function(opacity) {
      this.opacity_ = opacity;
    };

    /**
     * Set whether to rotate the style with the view.
     *
     * @param {boolean} rotateWithView Rotate with map.
     */
    ol.style.Image.prototype.setRotateWithView = function(rotateWithView) {
      this.rotateWithView_ = rotateWithView;
    };

    /**
     * Set the rotation.
     *
     * @param {number} rotation Rotation.
     * @api
     */
    ol.style.Image.prototype.setRotation = function(rotation) {
      this.rotation_ = rotation;
    };

    /**
     * Set the scale.
     *
     * @param {number} scale Scale.
     * @api
     */
    ol.style.Image.prototype.setScale = function(scale) {
      this.scale_ = scale;
    };

    /**
     * Set whether to snap the image to the closest pixel.
     *
     * @param {boolean} snapToPixel Snap to pixel?
     */
    ol.style.Image.prototype.setSnapToPixel = function(snapToPixel) {
      this.snapToPixel_ = snapToPixel;
    };

    /**
     * @param {function(this: T, ol.events.Event)} listener Listener function.
     * @param {T} thisArg Value to use as `this` when executing `listener`.
     * @return {ol.events.Key|undefined} Listener key.
     * @template T
     */
    ol.style.Image.prototype.listenImageChange = goog.abstractMethod;

    /**
     * Load not yet loaded URI.
     */
    ol.style.Image.prototype.load = goog.abstractMethod;

    /**
     * @param {function(this: T, ol.events.Event)} listener Listener function.
     * @param {T} thisArg Value to use as `this` when executing `listener`.
     * @template T
     */
    ol.style.Image.prototype.unlistenImageChange = goog.abstractMethod;